Program Vagas;
  Uses
    Crt,Graph;
  Const
    gPath='C:\langs\tp\bgi';
    {KpTartomnyt hatrol egyenesek paramterei (VGA-hoz igaztva):}
    KF0=100; KB0=100; KJ0=500; KA0=350;
    MaxX0=640; MaxY0=480;
    {Prba szakaszok szma:}
    SzakaszDb=5;
  Type
    TPont=Record x,y:Integer End;
    TSzakasz=Array [1..2] of TPont;
    TKod=0..12;
  Const
    {Prbaszakaszok:}
    sz:Array [1..SzakaszDb] of TSzakasz=(
                                 ((x:KB0+229;y:KF0+129),(x:KJ0-229;y:KA0-129)),
                                 ((x:KB0-19;y:KF0+19),(x:KB0+190;y:KF0+39)),
                                 ((x:KB0-9;y:KA0-19),(x:KJ0+19;y:KA0-99)),
                                 ((x:KB0-9;y:KF0-9),(x:KJ0+19;y:KF0-19)),
                                 ((x:KB0-59;y:KA0+59),(x:KJ0+69;y:KF0-69))
                                 );
    {Rajzol sznek:}
    kSzin = Red;  {szakasz kezd szne}
    vSzin = White;{vgleges, ltsz szakasz szne}
    tSzin = Green;{tartomnyt hatrol szn}
    {kzbls stcik szne:}
    szin:Array [1..4] of Byte=(Yellow,Magenta,Cyan,Blue);
  Var
    p1,p2:TPont;
    i:Integer;
    KF,KB,KA,KJ:Integer;

  Procedure Inic;
    Var
      i,j,
      gd,gm:Integer;
      nyX,nyY:Real;
  Begin
    DetectGraph(gd,gm);
    InitGraph(gd,gm,gPath);
    ClearDevice;
    {kpernyre transzformls (TP->FP miatt):}
    nyX:=GetMaxX/MaxX0; nyY:=GetMaxY/MaxY0;
    KF:=Round(KF0*nyY); KA:=Round(KA0*nyY);
    KB:=Round(KB0*nyX); KJ:=Round(KJ0*nyX);
    For i:=1 to SzakaszDb do
      For j:=1 to 2 do
      Begin
        sz[i,j].x:=Round(sz[i,j].x*nyX); sz[i,j].y:=Round(sz[i,j].y*nyY);
      End;
    SetColor(tSzin);
    SetLineStyle(DottedLn,0,NormWidth);
    Line(0,KF,GetMaxX,KF); Line(0,KA,GetMaxX,KA);
    Line(KB,0,KB,GetMaxX); Line(KJ,0,KJ,GetMaxY);
    SetLineStyle(SolidLn,0,ThickWidth);
    Rectangle(KB,KF,KJ,KA);
  End;

  Procedure Szakasz(Const p1,p2:TPont; szin:Byte);
  Begin
    SetColor(szin); SetLineStyle(SolidLn, 0, NormWidth);
    Circle(p1.x,p1.y,5); Circle(p2.x,p2.y,5);
    Circle(p1.x,p1.y,2); Circle(p2.x,p2.y,2);
    SetLineStyle(SolidLn,0,ThickWidth);
    Line(p1.x,p1.y,p2.x,p2.y);
  End;

  Procedure VegpontKod(Var c:TKod; Const p:TPont);
  Begin
    c:=0;
    If p.y<KF then c:=c OR 1;
    If p.x>KJ then c:=c OR 2;
    If p.y>KA then c:=c OR 4;
    If p.x<KB then c:=c OR 8;
  End;

  Procedure FelsoVagas(Var x1,y1,x2,y2:Integer);
  Begin
    x1:=Round(x1+(x2-x1)/(y2-y1)*(KF-y1));
    y1:=KF
  End;

  Procedure AlsoVagas(Var x1,y1,x2,y2:Integer);
  Begin
    x1:=Round(x1+(x2-x1)/(y2-y1)*(KA-y1));
    y1:=KA
  End;

  Procedure BalVagas(Var x1,y1,x2,y2:Integer);
  Begin
    y1:=Round(y1+(y2-y1)/(x2-x1)*(KB-x1));
    x1:=KB
  End;

  Procedure JobbVagas(Var x1,y1,x2,y2:Integer);
  Begin
    y1:=Round(y1+(y2-y1)/(x2-x1)*(KJ-x1));
    x1:=KJ
  End;

  Procedure CSVagas(Var p1,p2:TPont);
    Var
      c,c1,c2:TKod;
      p:TPont;
      cDb:Integer; {0<=cikluslpsek szma<=4}
  Begin
    VegpontKod(c1,p1); VegpontKod(c2,p2); cDb:=0;
    While not ((c1=0) and (c2=0)) {mg nem bell}
          and ((c1 AND c2)=0)  {nem biztos, hogy kvl} do
    Begin
      Inc(cDb);{jabb cikluslps}
      If c1=0 then
      Begin
        c:=c1; c1:=c2; c2:=c;
        p:=p1; p1:=p2; p2:=p;
      End;
      {p1 felli j metszspont meghatrozsa => p1}
      If
        (c1 AND 1)=1 then FelsoVagas(p1.x,p1.y,p2.x,p2.y) else if
        (c1 AND 2)=2 then JobbVagas(p1.x,p1.y,p2.x,p2.y) else if
        (c1 AND 4)=4 then AlsoVagas(p1.x,p1.y,p2.x,p2.y) else if
        (c1 AND 8)=8 then BalVagas(p1.x,p1.y,p2.x,p2.y)
      {EndIf};
      VegpontKod(c1,p1);
      {Metszspont-keress -- nyomkvets:}
      Szakasz(p1,p2,szin[cDb]);
      ReadKey;
      {Nyomkvets vge}
    End;
    If (c1=0) and (c2=0) then
    Begin {a bels szakasz kirajzolhat a vgs sznnel}
      Szakasz(p1,p2,vSzin);
    End;
  End;

Begin
  Inic;
  For i:=1 to SzakaszDB do
  Begin
    p1:=sz[i][1]; p2:=sz[i][2];
    Szakasz(p1,p2,kSzin);
    ReadKey;
    CSVagas(p1,p2);
    ReadKey
  End;
End.

                                 ((x:KB-9;y:KA+9),(x:KJ+19;y:KA-9)),
                                 ((x:KB-9;y:KF-9),(x:KJ+19;y:KF-9))
